#!/usr/bin/perl

# static char sccsid[] = "@(#)18 1.14 src/ll/config_editor/cgi-bin/on_add_panel.pl, ll.config, ll_rrnep2, rrnep21206a 5/15/11 18:09:58\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

debug_log($query);

# create the db connection
my $dbh = get_dbh(0);
if(!defined($dbh))
{
	error_and_exit(DBI->errstr);
}

# type=main&table=TLL_Cluster&name=&TLL_Cluster-name=trtr&TLL_Cluster-lldbVersion=22
# type=main&table=TLLR_CFGMachine&name=0&TLLR_CFGMachine-clusterID=3&TLLR_CFGMachine-name=bagbag&TLLR_CFGMachine-adapter_list=ss
# type=normal&table=TLLS_CFGMCluster&name=trtr&TLLS_CFGMCluster-clusterID=5&TLLS_CFGMCluster-cluster_metric=2&TLLS_CFGMCluster-cluster_remote_job_filter=2&TLLS_CFGMCluster-cluster_user_mapper=2&TLLS_CFGMCluster-scale_across_scheduling_timeout=2
# type=normal&table=TLLR_CFGMCluster&name=trtr&TLLR_CFGMCluster-clusterID=5&TLLR_CFGMCluster-allow_scale_across_jobs=2&TLLR_CFGMCluster-inbound_schedd_port=2&TLLR_CFGMCluster-local_flag=2&TLLR_CFGMCluster-main_scale_across_cluster=2&TLLR_CFGMCluster-classListType=I&TLLR_CFGMCluster-groupListType=E
my @keywords = split('&',$query);

# request type
my @type = split('=',$keywords[0]);

# table name
my @table = split('=',$keywords[1]);

# primary key
my @current_name = split('=',$keywords[2]);

my $add_str = "";
my $add_keys = "";
my $add_vals = "";
my $key_count = scalar(@keywords);
my $start_point = 3;
if($table[1] eq "TLLR_CFGMachine")
{
	# skip TLLR_CFGMachine-clusterID, because there is no clusterID field in table TLLR_CFGMachine.
	$start_point = 4;
}

# return the following string to js function
my $json_str = LLUtil::OUTPUT_HEADER;
my $return_id = "";
my $return_name = "";

# after adding into a 'main' table, we need to return the id of the new record.
if($type[1] eq "main")
{
	# format the insert statement 
	for(my $i = $start_point; $i < $key_count; $i++)
	{
		my @tmp = split('=',$keywords[$i]);
		my @left_keys = split('-',$tmp[0]);
		if(lc($left_keys[1]) eq "name")
		{
			$return_name = $tmp[1];
		}

		check_data($dbh,$table[1],$left_keys[1],$tmp[1],$return_name,"normal_add");
		$add_keys .= " ".$left_keys[1].",";
		$add_vals .= " '".$tmp[1]."',";
	}

	# before we insert a new record to "TLLR_CFGMachine", we should insert the new machine to "TLL_Nodelist"!!
	if($table[1] eq "TLLR_CFGMachine")
	{
		my @my_cluster = split('=',$keywords[3]);
		my $cluster_id_in_TLLR_CFGMachine = $my_cluster[1];

		#insert into TLL_Nodelist firstly
		my $insert_str = "insert into TLL_Nodelist (hostname,clusterID) values('".$return_name."',".$cluster_id_in_TLLR_CFGMachine.")";
		debug_log($insert_str);
		if(!defined($dbh->do($insert_str)))
		{
			error_and_exit($dbh->errstr);
		}
		$return_id = $dbh->last_insert_id(undef,undef,undef,undef);
		debug_log("return_id = ".$return_id);
		if ($return_id !~ /^\d+$/ ) {
			# Needs be an integer representing the id
			$add_str = "select * from TLL_Nodelist where hostname='".$return_name."'" ;
			my $sth = $dbh->prepare($add_str);
		
			if(!defined($sth->execute()))
			{
				my $tmp_dbh_errstr = $dbh->errstr."Cannot get the nodeID for ".$return_name;
				error_and_exit($tmp_dbh_errstr);
			}
			else
			{ 
				my @tmp = $sth->fetchrow_array;
				# the id is the first field
				$return_id = $tmp[0];
			}
		}		

	}

	if($table[1] eq "TLLR_CFGMachine")
	{
		$add_keys .= " nodeID";
		$add_vals .= " '".$return_id."'";
	}
	
	# remove the last ",".
	$add_keys =~ s/,$//g;
	$add_vals =~ s/,$//g;
	$add_str = "insert into ".$table[1]." (".$add_keys.") values(".$add_vals.")";
	debug_log($add_str);
	if(!defined($dbh->do($add_str)))
	{
		my $tmp_dbh_errstr = $dbh->errstr;
		debug_log("tmp_dbh_errstr: ".$tmp_dbh_errstr);
		
		# if fails to add into TLLR_CFGMachine, delete the record, which is added just now, in TLL_Nodelist.
		if($table[1] eq "TLLR_CFGMachine")
		{
			delete_by_id($dbh,"TLL_Nodelist","nodeID",$return_id);
		}
		error_and_exit($tmp_dbh_errstr);
	}
	
	# get the id of the new record.
	if($table[1] ne "TLLR_CFGMachine")
	{
		# works for MySQL not DB2
		$return_id = $dbh->last_insert_id(undef,undef,undef,undef);
		debug_log("return_id = ".$return_id);
		if ($return_id !~ /^\d+$/ ) {
			# Needs be an integer representing the id
			$add_str = "select * from ".$table[1]." where name='".$return_name."'" ;
			my $sth = $dbh->prepare($add_str);
		
			if(!defined($sth->execute()))
			{
				my $tmp_dbh_errstr = $dbh->errstr."Cannot get the ID for ".$return_name;
				error_and_exit($tmp_dbh_errstr);
			}
			else
			{ 
				my @tmp = $sth->fetchrow_array;
				# the id is the first field
				$return_id = $tmp[0];
			}
		}		

	}
	
}
elsif($type[1] eq "normal")
{
	# format the insert statement 
	for(my $i = $start_point; $i < $key_count; $i++)
	{
		my @tmp = split('=',$keywords[$i]);
		my @left_keys = split('-',$tmp[0]);

		check_data($dbh,$table[1],$left_keys[1],$tmp[1],$current_name[1],"normal_add");
		$add_keys .= " ".$left_keys[1].",";
		$add_vals .= " '".$tmp[1]."',";
	}
	
	# remove the last ","
	$add_keys =~ s/,$//g;
	$add_vals =~ s/,$//g;
	$add_str = "insert into ".$table[1]." (".$add_keys.") values(".$add_vals.")";
	if(!defined($dbh->do($add_str)))
	{
		error_and_exit($dbh->errstr);
	}
}
else
{
	error_and_exit("Error: unknown type - ".$type[1]);
}

$dbh->disconnect();
$json_str .= "({result:'OK',key:'".$return_id."',name:'".$return_name."'})";
print $json_str;
