#!/usr/bin/perl

# static char sccsid[] = "@(#)27 1.13 src/ll/config_editor/cgi-bin/pull_down_tab_panel_machine_groups.pl, ll.config, ll_rrnep2, rrnep21206a 10/4/10 13:27:01\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my ($db_host, $db_user, $db_pass, $db_db, $db_conn, $db2inst) = get_db_info(0);

my @normal_tables_by_mgID = @{LLUtil::ALL_TABLES->{"tab_panel_machine_groups"}->[0]};
my @editable_tables_by_mgID = @{LLUtil::ALL_TABLES->{"tab_panel_machine_groups"}->[1]};
my @multi_select_tables_by_mgID = @{LLUtil::ALL_TABLES->{"tab_panel_machine_groups"}->[2]};

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

$_ = $query;
if(/id=(\d+)&name=(.*)&cluster=(\d+)/)
{
	my $json_str_0 = "Content-type: text/html\n\n";
	my $dbh = get_dbh(0);
	if(!defined($dbh))
	{
		error_and_exit($dbh->errstr);
	}
	
	my $mgID = $1;
	my $option_name = $2;
	my $cluster_id = $3;

	my $sql_str;
	my $sth;

	my $json_str = $json_str_0."[";

	# Get default mg id
	my $default_mg_id = undef;
	if($mgID != 0)
	{
		$default_mg_id = get_default_id_by_primary_key($dbh,"mgID","clusterID","TLL_MachineGroup","name",$mgID);
	}
	else
	{
		$default_mg_id = get_default_id($dbh,"mgID","name","TLL_MachineGroup",$cluster_id);
	}
	
	# Get default values
	if(defined($default_mg_id))
	{
		my $is_default = 0;
		if($default_mg_id == $mgID) { $is_default = 1; }		
		$json_str .= get_default_json_str($dbh,"tab_panel_machine_groups","mgID",$default_mg_id,$is_default);
	}
	
	if($mgID != 0)
	{
		
	foreach my $table (@normal_tables_by_mgID)
	{
		$sql_str="select * from ".$table." where mgID=".$mgID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}			
		my $ary_ref = $sth->fetchrow_arrayref;
		my $i = 0;
		$json_str .= "{type:'normal',id:'".$table."-id"."',value:'".$mgID."'},";
		if(exists $ary_ref->[$i])
		{
			for($i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
			{
				$json_str .= "{type:'normal',id:'".$table."-".$sth->{NAME}->[$i]."',value:'".$ary_ref->[$i]."'},";
			}
		}
	}
	
	foreach my $table (@editable_tables_by_mgID)
	{
		$sql_str="select * from ".$table." where mgID=".$mgID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}
		$json_str .= "{type:'editable',table_name:'".$table."',key_id:'".$mgID."',rows:[";
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
			$json_str .= "{columns:[";
			for(my $i=1;$i<$sth->{NUM_OF_FIELDS};$i++)
			{
				$json_str .= "{col_name:'".$sth->{NAME}->[$i]."',col_value:'".$ary_ref->[$i]."',col_title:'".$sth->{NAME}->[$i]."'},";
			}
			$json_str =~ s/,$//g;
			$json_str .= "]},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}

	foreach my $table (@multi_select_tables_by_mgID)
	{
		$sql_str="select * from ".$table." where mgID=".$mgID;
		$sth=$dbh->prepare($sql_str);
		if(!defined($sth->execute()))
		{
			my $json_str_err = $json_str_0."Error:".$dbh->errstr;
			print $json_str_err;
			exit 1;
		}
		$json_str .= "{type:'multisel',table_name:'".$table."',key_id:'".$mgID."',values:[";
		while(my $ary_ref = $sth->fetchrow_arrayref)
		{
		    $json_str .= "{a:'".$ary_ref->[1]."'},";
		}
		$json_str =~ s/,$//g;
		$json_str .= "]},";
	}

	} # $mgID != 0
	
	$json_str =~ s/,$//g;
	$json_str .= "]";
	if(defined($sth)) {$sth->finish();}
	
	print $json_str;
	$dbh->disconnect();

}
